/* interface.h - 
   Copyright (C) 1999 Tijs van Bakel.
   Tijs van Bakel <smoke@casema.net>, 
 
 This file is part of the bizarre99 linux invitation intro.

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */

#ifndef __INTERFACE_H
#define __INTERFACE_H

#include "types.h"
#include "invtro.h"
#include "screen.h"
#include "graphics.h"
#include "modplay.h"
#include "text.h"

#define LOGO_WIDTH 40
#define LOGO_HEIGHT 200

#define PALETTE_WRITERFONT_BASE (256-32)
#define PALETTE_BACKGROUND_BASE (256-32)

#define WINDOW_X0 (32+32)
#define WINDOW_Y0 (32)
#define WINDOW_X1 (320-32)
#define WINDOW_Y1 (200-16)

/* pages are layed out as follows
   0 1
   2 3 */
void doInterface( struct screen* scrn, struct graphics* g, struct music* m, struct text* t ); 

#endif /* __INTERFACE_H */
